=== debian/changelog ===
lfortran (0.58.0-6) unstable; urgency=medium

  * Update dep on clang to clang-21 for autopkgtests
  * sh m68k x32 also don't have pandoc
  * hurd-amd64 loong64 dont have libunwind-dev
  * Drop ZSTD support that FTBFS on armhf

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Jan 2026 08:35:14 +0000

lfortran (0.58.0-5) unstable; urgency=medium

  * Drop Priority: optional from source in d/control per new policy
  * Standards-Version: 4.7.3
  * Add build-dep on python3 for script
  * d/copyright file fixes for licenserecon -x
  * Pandoc not available on loong64 yet; don't build manpages there

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 06 Jan 2026 16:55:47 +0000

lfortran (0.58.0-4) unstable; urgency=medium

  * Add d/clean so repeated builds work
  * Fix StaticBFD patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Dec 2025 06:38:56 +0000

lfortran (0.58.0-3) experimental; urgency=medium

  * Fix UNWIND detection and builds; need to avoid LLVM etc if UNWIND not
    used. This may enable other archs, but may require statically linked
    zstd and zlib. Test in experimental
  * Build-dep on libedit-dev
  * Delete obsolete clang-19.patch
  * lfortran mod compatibility breaks on each release. Change moddir

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 20 Dec 2025 09:18:51 +0000

lfortran (0.58.0-2) unstable; urgency=medium

  * Move to llvm-21
  * Don't use UNWIND on armhf; FTBFS with missing _Unwind_GetIP
  * Include d/salsa-ci.yml

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Dec 2025 08:11:26 +0000

lfortran (0.58.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Dec 2025 13:45:46 +0000
