=== debian/control ===
Source: lfortran
Section: devel
Standards-Version: 4.7.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends:  debhelper-compat (= 13),
 cmake,
 re2c,
 bison,
 pandoc [!loong64 !sh !m68k !x32],
 python3,
 libfmt-dev,
 libedit-dev,
 libsframe-dev,
 llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa],
 libunwind-dev [!armhf !hurd-i386 !hurd-amd64 !loong64 !sparc64 !powerpc !alpha !hppa],
 libjsoncpp-dev,
 binutils-dev,
 libiberty-dev,
 libzstd-dev,
 libcurl4-gnutls-dev,
 rapidjson-dev,
 xeus-dev, xeus-zmq-dev,
 zlib1g-dev
Homepage: https://lfortran.org
Vcs-Browser: https://salsa.debian.org/science-team/lfortran
Vcs-Git: https://salsa.debian.org/science-team/lfortran.git

Package: lfortran
Architecture: any
Provides: fortran-compiler, lfortran-mod-0
Built-Using: ${Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}, liblfortran-runtime0 ( = ${binary:Version}), 
 clang-21,
 python3:any ,
 liblfortran-dev ( = ${binary:Version}),
Description: Modern interactive LLVM-based Fortran compiler
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.

Package: liblfortran-runtime0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Runtime libraries for the lfortran compiler
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.
 .
 This provides the lfortran runtime libraries.

Package: liblfortran-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, liblfortran-runtime0 (= ${binary:Version})
Description: flang library - Development package.
 LFortran is a modern open-source (BSD licensed) interactive Fortran compiler
 built on top of LLVM. It can execute user’s code interactively to allow 
 exploratory work (much like Python, MATLAB or Julia) as well as compile
 to binaries with the goal to run user’s code on modern architectures such 
 as multi-core CPUs and GPUs.
 .
 This provides the static libraries and development files.
