## lfortran 0.59.0

=== integration_tests/CMakeLists.txt ===
--- 
+++ 
@@ -137,6 +137,19 @@
             add_executable(${name} ${file_name}.f90 ${extra_files})
             target_compile_options(${name} PUBLIC --backend=c --ignore-pragma ${extra_args})
             add_test(${name} ${CURRENT_BINARY_DIR}/${name})
+        elseif (LFORTRAN_BACKEND STREQUAL "llvm_single_invocation")
+            set(extra_files_full ${extra_files})
+            list(TRANSFORM extra_files_full PREPEND "${CMAKE_CURRENT_SOURCE_DIR}/")
+            add_custom_command(
+                OUTPUT ${CURRENT_BINARY_DIR}/${name}
+                COMMAND lfortran -I${CMAKE_CURRENT_SOURCE_DIR} ${extra_args}
+                    ${extra_files_full} ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
+                    -o ${CURRENT_BINARY_DIR}/${name}
+                DEPENDS ${extra_files_full} ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
+                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+            )
+            add_custom_target(${name}_single_invocation ALL DEPENDS ${CURRENT_BINARY_DIR}/${name})
+            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
         elseif (LFORTRAN_BACKEND STREQUAL "llvm")
             add_executable(${name} ${file_name}.f90 ${extra_files})
             target_compile_options(${name} PUBLIC $<$<COMPILE_LANGUAGE:Fortran>:${extra_args}>)
@@ -209,24 +222,3 @@
                 ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
             add_test(${name} ${CURRENT_BINARY_DIR}/${name})
         elseif (LFORTRAN_BACKEND STREQUAL "mlir_llvm_omp")
-            execute_process(COMMAND lfortran ${extra_args} --backend=llvm
-                --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib
-                --mlir-gpu-offloading
-                ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
-            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
-        else ()
-            add_executable(${name} ${file_name}.f90 ${extra_files})
-            target_compile_options(${name} PUBLIC ${gfortran_args})
-            target_link_options(${name} PUBLIC ${gfortran_args})
-            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
-        endif()
-
-        if (labels)
-            set_tests_properties(${name} PROPERTIES LABELS "${labels}")
-        endif()
-
-        if (fail)
-            set_tests_properties(${name} PROPERTIES WILL_FAIL TRUE)
-        endif()
-
-        if (copy_to_bin)
