=== debian/changelog ===
lfortran (0.59.0-3) unstable; urgency=medium

  * Fix missing d/copyright line
  * Fix d/rules: dont use llvm/unwind on loong64

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Feb 2026 09:14:50 +0000

lfortran (0.59.0-2) unstable; urgency=medium

  * Unwind-dev missing on loong64 too
  * Also don't build man pages on hurd-i386 hurd-amd64 sh4 x32 m68k; no
    pandoc available
  * d/gpb.conf: pristine-tar = True
  * Set module dir to lfortran-mod-0
  * zstd.patch: ensure zstd used at all times. Fixes FTBFS on  armhf

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 31 Jan 2026 12:11:29 +0000

lfortran (0.59.0-1) unstable; urgency=medium

  * Add d/watch file
  * New upstream release
  * Update static-bfd.patch
  * liblfortran_c.patch: fix linking bfd
  * Fix to d/copyright license name
  * Re-include hard-coded clang-* path

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 30 Jan 2026 16:25:02 +0000
