=== debian/control ===
--- 
+++ 
@@ -7,13 +7,13 @@
  cmake,
  re2c,
  bison,
- pandoc [!loong64 !sh !m68k !x32],
+ pandoc [!loong64 !hurd-i386 !hurd-amd64 !sh4 !x32 !m68k],
  python3,
  libfmt-dev,
  libedit-dev,
  libsframe-dev,
- llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa],
- libunwind-dev [!armhf !hurd-i386 !hurd-amd64 !loong64 !sparc64 !powerpc !alpha !hppa],
+ llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
+ libunwind-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
  libjsoncpp-dev,
  binutils-dev,
  libiberty-dev,
@@ -24,7 +24,7 @@
  zlib1g-dev
 Homepage: https://lfortran.org
 Vcs-Browser: https://salsa.debian.org/science-team/lfortran
-Vcs-Git: https://salsa.debian.org/science-team/lfortran.git
+Vcs-Git: https://salsa.debian.org/science-team/lfortran.git -b debian/latest
 
 Package: lfortran
 Architecture: any
