=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # not currently compiling ?
 
 # _Unwind_GetIP missing on armhf
-UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 hurd-amd64 loong64 sparc64 powerpc alpha hppa ),no,yes  )
+UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 sparc64 powerpc alpha hppa loong64 ),no,yes  )
 
 override_dh_auto_configure:
 	echo $(DEB_VERSION_UPSTREAM) > version
@@ -36,13 +36,13 @@
 		-DWITH_BFD=yes	\
 		-DLLVM_DIR=/usr/lib/llvm-21/cmake \
 		-DWITH_KOKKOS=yes \
-		-DCMAKE_Fortran_MODULE_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/lfortran-mod-$(DEB_VERSION_UPSTREAM)
+		-DCMAKE_Fortran_MODULE_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/lfortran-mod-0
 
 
 override_dh_gencontrol:
 	dh_gencontrol -- -VBuilt-Using="`dpkg-query -f'$${source:Package} (= $${source:Version}), ' -W binutils-dev libiberty-dev`"
 
-ifneq (,$(filter $(DEB_BUILD_ARCH),loong64 sh m68k x32))
+ifneq (,$(filter $(DEB_BUILD_ARCH),loong64 hurd-i386 hurd-amd64 sh4 x32 m68k ))
 override_dh_installman:
 	@echo "Not installing man pages; pandoc missing"
 endif
