## lfortran 0.60.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -132,7 +132,8 @@
 
     # Find ZLIB with our custom finder before including LLVM since the finder for LLVM
     # might search for ZLIB again and find the shared libraries instead of the static ones
-    find_package(StaticZLIB REQUIRED)
+    set(USE_DYNAMIC_ZLIB no CACHE BOOL "Use dynamic ZLIB library (default: static)")
+    find_package(LFortranZLIB REQUIRED)
 endif()
 
 if (WITH_LCOMPILERS_FAST_ALLOC)
@@ -215,9 +216,10 @@
 endif()
 
 if (WITH_LLVM)
-    set(WITH_ZSTD yes CACHE BOOL "Detect (and require) static libzstd for llvm")
+    set(WITH_ZSTD yes CACHE BOOL "Detect (and require) libzstd for LLVM")
+    set(USE_DYNAMIC_ZSTD no CACHE BOOL "Use dynamic ZSTD library (default: static)")
     if(WITH_ZSTD)
-        find_package(StaticZSTD REQUIRED)
+        find_package(LFortranZSTD REQUIRED)
     endif()
 
     set(LFORTRAN_LLVM_COMPONENTS core support mcjit orcjit native asmparser asmprinter)
@@ -352,10 +354,3 @@
 
 # JSON OR LSP (`conda install rapidjson`)
 set(WITH_JSON no CACHE BOOL "Build with JSON support")
-set(WITH_LSP no CACHE BOOL "Build with LSP support")
-if (WITH_JSON)
-    find_package(RapidJSON REQUIRED)
-    set(HAVE_LFORTRAN_RAPIDJSON yes)
-endif()
-
-set(HAVE_LFORTRAN_DEMANGLE yes
