=== integration_tests/CMakeLists.txt ===
--- 
+++ 
@@ -129,6 +129,10 @@
             execute_process(COMMAND lfortran ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
                 ${extra_args} --stack-arrays=true -o ${name})
             add_test(${name} ${CURRENT_BINARY_DIR}/${name})
+        elseif (LFORTRAN_BACKEND STREQUAL "llvm_integer_8")
+            execute_process(COMMAND lfortran ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90
+                ${extra_args} -fdefault-integer-8 -o ${name})
+            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
         elseif (LFORTRAN_BACKEND STREQUAL "llvm_nopragma")
             add_executable(${name} ${file_name}.f90 ${extra_files})
             target_compile_options(${name} PUBLIC --ignore-pragma ${extra_args})
@@ -218,7 +222,3 @@
         elseif (LFORTRAN_BACKEND STREQUAL "mlir_omp")
             execute_process(COMMAND lfortran ${extra_args} --backend=mlir
                 --openmp --openmp-lib-dir=$ENV{CONDA_PREFIX}/lib
-                --mlir-gpu-offloading
-                ${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.f90 -o ${name})
-            add_test(${name} ${CURRENT_BINARY_DIR}/${name})
-        elseif (LFORTRAN_BACKEND STREQUAL "mlir_llvm_omp")
