=== debian/changelog ===
lfortran (0.60.0-1) unstable; urgency=medium

  * llvm/unwind also unavailable on x32,m68k,sh4 archs
  * New upstream release
  * d/gbp.conf: Revert upstream branch to 'upstream'
  * Drop / from paths in install files

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 08 Feb 2026 17:01:50 +0000
