=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
  libfmt-dev,
  libedit-dev,
  libsframe-dev,
- llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
- libunwind-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64],
+ llvm-21-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64 !m68k !sh4 !x32],
+ libunwind-dev [!armhf !hurd-i386 !sparc64 !powerpc !alpha !hppa !loong64 !m68k !sh4 !x32],
  libjsoncpp-dev,
  binutils-dev,
  libiberty-dev,
