=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 # not currently compiling ?
 
 # _Unwind_GetIP missing on armhf
-UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 sparc64 powerpc alpha hppa loong64 ),no,yes  )
+UNWIND:= $(if $(filter $(DEB_TARGET_ARCH), armhf hurd-i386 sparc64 powerpc alpha hppa loong64 m68k sh4 x32 ),no,yes  )
 
 override_dh_auto_configure:
 	echo $(DEB_VERSION_UPSTREAM) > version
